package com.amqp.shanxi;

import com.amqp.shanxi.service.AlarmDataAMQPService;
import com.amqp.shanxi.service.DeviceStaticDataAMQPService;
import com.amqp.shanxi.service.RealTimeDataAMQPService;
import com.amqp.shanxi.service.ThreadService;
import com.rabbitmq.client.Connection;
import com.rabbitmq.client.ConnectionFactory;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.context.ConfigurableApplicationContext;

@SpringBootApplication
public class ShanxiApplication {

    public static void main(String[] args) {
        ConfigurableApplicationContext run = SpringApplication.run(ShanxiApplication.class, args);
        DeviceStaticDataAMQPService deviceStaticDataAMQPService = run.getBean(DeviceStaticDataAMQPService.class);
        RealTimeDataAMQPService realTimeDataAMQPService = run.getBean(RealTimeDataAMQPService.class);
        AlarmDataAMQPService alarmDataAMQPService = run.getBean(AlarmDataAMQPService.class);

        try{
            ConnectionFactory factory = new ConnectionFactory();
            //rabbitmq监听IP
            factory.setHost("114.115.212.187");
            //rabbitmq监听默认端口
            factory.setPort(5672);
            //设置访问的用户
            factory.setUsername("bhsoft");
            factory.setPassword("bhsoft");
            factory.setVirtualHost("/");
            Connection connection = factory.newConnection();
            ThreadService threadService1 = new ThreadService("staticData", connection, deviceStaticDataAMQPService, realTimeDataAMQPService, alarmDataAMQPService);
            ThreadService threadService2 = new ThreadService("realTimeData", connection, deviceStaticDataAMQPService, realTimeDataAMQPService,alarmDataAMQPService);
            ThreadService threadService3 = new ThreadService("alarmData", connection, deviceStaticDataAMQPService, realTimeDataAMQPService,alarmDataAMQPService);
            threadService1.start();
            threadService2.start();
            threadService3.start();
        } catch(Exception e) {
            e.printStackTrace();
        }
    }

}
