package com.amqp.shanxi.service;

import com.amqp.shanxi.util.AMQPTopicStaticDataConfig;
import com.rabbitmq.client.Channel;
import com.rabbitmq.client.Connection;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class AlarmDataAMQPService {

    @Autowired
    private AlarmDataService alarmDataService;

    /**
     * 实时数据推送入口
     */
    public void run(Connection connection) {
        publishAlarm("gt", connection);
        publishAlarm("ksw", connection);
        publishAlarm("bmwy", connection);
        publishAlarm("nbwy", connection);
        publishAlarm("jrx", connection);
        publishAlarm("jyl", connection);
        publishAlarm("device", connection);
        publishAlarm("wkk", connection);
    }

    public void publishAlarm(String type, Connection connection) {
        try {
            if ("gt".equals(type)) {
                Channel channel = connection.createChannel();
                // channel.exchangeDeclare(AMQPTopicStaticDataConfig.topicExchangeRealTime, "topic", false, true, null);
                channel.basicPublish(AMQPTopicStaticDataConfig.topicExchangeRealTime
                        , AMQPTopicStaticDataConfig.TOPICQUEUEGANtANALARM
                        , null
                        , alarmDataService.gantanAlarm().getBytes());
                //消息确认
                channel.confirmSelect();
                if (channel.waitForConfirms()) {
                    System.out.println("干滩报警信息发送成功！");
                } else {
                    System.out.println("干滩报警信息发送失败！");
                }
                channel.close();
            } else if ("ksw".equals(type)) {
                Channel channel = connection.createChannel();
                // channel.exchangeDeclare(AMQPTopicStaticDataConfig.topicExchangeRealTime, "topic", false, true, null);
                channel.basicPublish(AMQPTopicStaticDataConfig.topicExchangeRealTime
                        , AMQPTopicStaticDataConfig.TOPICQUEUEKUSHUIWEIALARM
                        , null
                        , alarmDataService.kushuiweiAlarm().getBytes());
                //消息确认
                channel.confirmSelect();
                if (channel.waitForConfirms()) {
                    System.out.println("库水位报警信息发送成功！");
                } else {
                    System.out.println("库水位报警信息发送失败！");
                }
                channel.close();
            } else if ("bmwy".equals(type)) {
                Channel channel = connection.createChannel();
                // channel.exchangeDeclare(AMQPTopicStaticDataConfig.topicExchangeRealTime, "topic", false, true, null);
                channel.basicPublish(AMQPTopicStaticDataConfig.topicExchangeRealTime
                        , AMQPTopicStaticDataConfig.TOPICQUEUEBIAOMIANWEIYIALARM
                        , null
                        , alarmDataService.biaomianweiyiAlarm().getBytes());
                //消息确认
                channel.confirmSelect();
                if (channel.waitForConfirms()) {
                    System.out.println("表面位移报警信息发送成功！");
                } else {
                    System.out.println("表面位移报警信息发送失败！");
                }
                channel.close();
            } else if ("nbwy".equals(type)) {
                Channel channel = connection.createChannel();
                // channel.exchangeDeclare(AMQPTopicStaticDataConfig.topicExchangeRealTime, "topic", false, true, null);
                channel.basicPublish(AMQPTopicStaticDataConfig.topicExchangeRealTime
                        , AMQPTopicStaticDataConfig.TOPICQUEUENEIBUWEIYIALARM
                        , null
                        , alarmDataService.neibushuipingAlarm().getBytes());
                //消息确认
                channel.confirmSelect();
                if (channel.waitForConfirms()) {
                    System.out.println("内部水平报警信息发送成功！");
                } else {
                    System.out.println("内部水平报警信息发送失败！");
                }

                // ====================内部沉降
                // channel.exchangeDeclare(AMQPTopicStaticDataConfig.topicExchangeRealTime, "topic", false, true, null);
                channel.basicPublish(AMQPTopicStaticDataConfig.topicExchangeRealTime
                        , AMQPTopicStaticDataConfig.TOPICQUEUENEIBUWEIYIALARM
                        , null
                        , alarmDataService.neibuchenjiangAlarm().getBytes());
                //消息确认
                channel.confirmSelect();
                if (channel.waitForConfirms()) {
                    System.out.println("内部沉降报警信息发送成功！");
                } else {
                    System.out.println("内部沉降报警信息发送失败！");
                }

                channel.close();
            } else if ("jrx".equals(type)) {
                Channel channel = connection.createChannel();
                // channel.exchangeDeclare(AMQPTopicStaticDataConfig.topicExchangeRealTime, "topic", false, true, null);
                channel.basicPublish(AMQPTopicStaticDataConfig.topicExchangeRealTime
                        , AMQPTopicStaticDataConfig.TOPICQUEUEJINRUNXIANALARM
                        , null
                        , alarmDataService.jinrunxianAlarm().getBytes());
                //消息确认
                channel.confirmSelect();
                if (channel.waitForConfirms()) {
                    System.out.println("浸润线报警信息发送成功！");
                } else {
                    System.out.println("浸润线报警信息发送失败！");
                }
                channel.close();
            } else if ("jyl".equals(type)) {
                Channel channel = connection.createChannel();
                // channel.exchangeDeclare(AMQPTopicStaticDataConfig.topicExchangeRealTime, "topic", false, true, null);
                channel.basicPublish(AMQPTopicStaticDataConfig.topicExchangeRealTime
                        , AMQPTopicStaticDataConfig.TOPICQUEUEJIANGYULIANGALARM
                        , null
                        , alarmDataService.jiangyuliangAlarm().getBytes());
                //消息确认
                channel.confirmSelect();
                if (channel.waitForConfirms()) {
                    System.out.println("降雨量报警信息发送成功！");
                } else {
                    System.out.println("降雨量报警信息发送失败！");
                }
                channel.close();
            } else if ("sll".equals(type)) {

            } else if ("device".equals(type)) {
                // 监测项数据信息
                Channel channel = connection.createChannel();
                // channel.exchangeDeclare(AMQPTopicStaticDataConfig.topicExchangeRealTime, "topic", false, true, null);
                channel.basicPublish(AMQPTopicStaticDataConfig.topicExchangeRealTime
                        , AMQPTopicStaticDataConfig.TOPICQUEUEDEVICEALARM
                        , null
                        , alarmDataService.deviceAlarm().getBytes());
                //消息确认
                channel.confirmSelect();
                if (channel.waitForConfirms()) {
                    System.out.println("检测项报警信息发送成功！");
                } else {
                    System.out.println("检测项报警信息发送失败！");
                }
                channel.close();
            } else if ("wkk".equals(type)) {
                // 尾矿库数据信息
                Channel channel = connection.createChannel();
                // channel.exchangeDeclare(AMQPTopicStaticDataConfig.topicExchangeRealTime, "topic", false, true, null);
                channel.basicPublish(AMQPTopicStaticDataConfig.topicExchangeRealTime
                        , AMQPTopicStaticDataConfig.TOPICQUEUEWKKALARM
                        , null
                        , alarmDataService.wkkAlarm().getBytes());
                //消息确认
                channel.confirmSelect();
                if (channel.waitForConfirms()) {
                    System.out.println("尾矿库报警信息发送成功！");
                } else {
                    System.out.println("尾矿库报警信息发送失败！");
                }
                channel.close();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

/*
    @RabbitListener(queues ="equipOfflineInfo" )
    public void receiveMessage1(String str){
        System.out.println("我是监听干滩topic.message的, dataInfo.01:    " + str);
    }
*/

}
