package com.amqp.shanxi.service;

import cn.hutool.json.JSONUtil;
import com.amqp.shanxi.util.AMQPTopicStaticDataConfig;
import com.rabbitmq.client.Channel;
import com.rabbitmq.client.Connection;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class RealTimeDataAMQPService {

    @Autowired
    private RealTimeInfoService realTimeInfoService;


    /**
     * 实时数据推送入口
     */
    public void run(Connection connection) {
        publishRealTime("gt", connection);
        publishRealTime("ksw", connection);
        publishRealTime("bmwy", connection);
        publishRealTime("nbwy", connection);
        publishRealTime("jrx", connection);
        publishRealTime("jyl", connection);
        publishRealTime("device", connection);
        publishRealTime("wkk", connection);
        publishRealTime("offline", connection);
    }

    public void publishRealTime(String type, Connection connection) {
        try {
            if ("gt".equals(type)) {
                Channel channel = connection.createChannel();
                // channel.exchangeDeclare(AMQPTopicStaticDataConfig.topicExchangeRealTime, "topic", false, true, null);
                channel.basicPublish(AMQPTopicStaticDataConfig.topicExchangeRealTime
                        , AMQPTopicStaticDataConfig.TOPICQUEUEGANTANREALTIME
                        , null
                        , realTimeInfoService.gantanRealTimeData().getBytes());
                //消息确认
                channel.confirmSelect();
                if (channel.waitForConfirms()) {
                    System.out.println("干滩实时数据发送成功！");
                } else {
                    System.out.println("干滩实时数据发送失败！");
                }
                channel.close();

            } else if ("ksw".equals(type)) {
                Channel channel = connection.createChannel();
                // channel.exchangeDeclare(AMQPTopicStaticDataConfig.topicExchangeRealTime, "topic", false, true, null);
                channel.basicPublish(AMQPTopicStaticDataConfig.topicExchangeRealTime
                        , AMQPTopicStaticDataConfig.TOPICQUEUEKUSHUIWEIREALTIME
                        , null
                        , realTimeInfoService.kushuiweiRealTimeData().getBytes());
                //消息确认
                channel.confirmSelect();
                if (channel.waitForConfirms()) {
                    System.out.println("库水位实时数据发送成功！");
                } else {
                    System.out.println("库水位实时数据发送失败！");
                }
                channel.close();

            } else if ("bmwy".equals(type)) {
                Channel channel = connection.createChannel();
                // channel.exchangeDeclare(AMQPTopicStaticDataConfig.topicExchangeRealTime, "topic", false, true, null);
                channel.basicPublish(AMQPTopicStaticDataConfig.topicExchangeRealTime
                        , AMQPTopicStaticDataConfig.TOPICQUEUEBIAOMIANWEIYIREALTIME
                        , null
                        , realTimeInfoService.biaomianweiyiRealTimeData().getBytes());
                //消息确认
                channel.confirmSelect();
                if (channel.waitForConfirms()) {
                    System.out.println("表面位移实时数据发送成功！");
                } else {
                    System.out.println("表面位移实时数据发送失败！");
                }
                channel.close();

            } else if ("nbwy".equals(type)) {
                Channel channel = connection.createChannel();
                // channel.exchangeDeclare(AMQPTopicStaticDataConfig.topicExchangeRealTime, "topic", false, true, null);
                channel.basicPublish(AMQPTopicStaticDataConfig.topicExchangeRealTime
                        , AMQPTopicStaticDataConfig.TOPICQUEUENEIBUWEIYIREALTIME
                        , null
                        , realTimeInfoService.neibuChenJiangRealTimeData().getBytes());
                //消息确认
                channel.confirmSelect();
                if (channel.waitForConfirms()) {
                    System.out.println("内部沉降实时数据发送成功！");
                } else {
                    System.out.println("内部沉降实时数据发送失败！");
                }


                channel.basicPublish(AMQPTopicStaticDataConfig.topicExchangeRealTime
                        , AMQPTopicStaticDataConfig.TOPICQUEUENEIBUWEIYIREALTIME
                        , null
                        , realTimeInfoService.neibuShuiPingRealTimeData().getBytes());
                //消息确认
                channel.confirmSelect();
                if (channel.waitForConfirms()) {
                    System.out.println("内部水平实时数据发送成功！");
                } else {
                    System.out.println("内部水平实时数据发送失败！");
                }
                channel.close();

            } else if ("jrx".equals(type)) {
                Channel channel = connection.createChannel();
                // channel.exchangeDeclare(AMQPTopicStaticDataConfig.topicExchangeRealTime, "topic", false, true, null);
                channel.basicPublish(AMQPTopicStaticDataConfig.topicExchangeRealTime
                        , AMQPTopicStaticDataConfig.TOPICQUEUEJINRUNXIANREALTIME
                        , null
                        , realTimeInfoService.jinrunxianRealTimeData().getBytes());
                //消息确认
                channel.confirmSelect();
                if (channel.waitForConfirms()) {
                    System.out.println("浸润线实时数据发送成功！");
                } else {
                    System.out.println("浸润线实时数据发送失败！");
                }
                channel.close();

            } else if ("jyl".equals(type)) {
                Channel channel = connection.createChannel();
                // channel.exchangeDeclare(AMQPTopicStaticDataConfig.topicExchangeRealTime, "topic", false, true, null);
                channel.basicPublish(AMQPTopicStaticDataConfig.topicExchangeRealTime
                        , AMQPTopicStaticDataConfig.TOPICQUEUEJIANGYULIANGREALTIME
                        , null
                        , realTimeInfoService.jiangyuliangRealTimeData().getBytes());
                //消息确认
                channel.confirmSelect();
                if (channel.waitForConfirms()) {
                    System.out.println("降雨量实时数据发送成功！");
                } else {
                    System.out.println("降雨量实时数据发送失败！");
                }
                channel.close();

            } else if ("sll".equals(type)) {

            } else if ("device".equals(type)) {
                // 监测项数据信息
                Channel channel = connection.createChannel();
                // channel.exchangeDeclare(AMQPTopicStaticDataConfig.topicExchangeRealTime, "topic", false, true, null);
                channel.basicPublish(AMQPTopicStaticDataConfig.topicExchangeRealTime
                        , AMQPTopicStaticDataConfig.TOPICQUEUEDEVICEREALTIME
                        , null
                        , realTimeInfoService.deviceRealTimeData().getBytes());
                //消息确认
                channel.confirmSelect();
                if (channel.waitForConfirms()) {
                    System.out.println("检测项实时数据发送成功！");
                } else {
                    System.out.println("检测项实时数据发送失败！");
                }
                channel.close();

            } else if ("wkk".equals(type)) {
                // 尾矿库数据信息
                Channel channel = connection.createChannel();
                // channel.exchangeDeclare(AMQPTopicStaticDataConfig.topicExchangeRealTime, "topic", false, true, null);
                channel.basicPublish(AMQPTopicStaticDataConfig.topicExchangeRealTime
                        , AMQPTopicStaticDataConfig.TOPICQUEUEWKKREALTIME
                        , null
                        , realTimeInfoService.wkkRealTimeData().getBytes());
                //消息确认
                channel.confirmSelect();
                if (channel.waitForConfirms()) {
                    System.out.println("尾矿库实时数据发送成功！");
                } else {
                    System.out.println("尾矿库实时数据发送失败！");
                }
                channel.close();

            } else if ("offline".equals(type)) {
                // 设备离线
                Channel channel = connection.createChannel();
                // channel.exchangeDeclare(AMQPTopicStaticDataConfig.topicExchangeRealTime, "topic", false, true, null);
                channel.basicPublish(AMQPTopicStaticDataConfig.topicExchangeRealTime
                        , AMQPTopicStaticDataConfig.TOPICQUEUEOFFLINEINFO
                        , null
                        , realTimeInfoService.deviceOffLineData().getBytes());
                //消息确认
                channel.confirmSelect();
                if (channel.waitForConfirms()) {
                    System.out.println("设备离线实时数据发送成功！");
                } else {
                    System.out.println("设备离线实时数据发送失败！");
                }
                channel.close();

            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

/*
    @RabbitListener(queues ="equipOfflineInfo" )
    public void receiveMessage1(String str){
        System.out.println("我是监听干滩topic.message的, dataInfo.01:    " + str);
    }
*/

}
