package com.amqp.shanxi.service.impl;

import cn.hutool.json.JSONUtil;
import com.amqp.shanxi.dao.DeviceStaticDataInfoDao;
import com.amqp.shanxi.model.*;
import com.amqp.shanxi.service.DeviceStaticDataInfoService;
import com.amqp.shanxi.util.AESUtil;
import com.amqp.shanxi.util.StaticParamUtils;
import com.rabbitmq.client.AMQP;
import com.rabbitmq.client.Channel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

@Service
public class DeviceStaticDataInfoServiceImpl implements DeviceStaticDataInfoService {


    @Autowired
    public DeviceStaticDataInfoDao deviceStaticDataInfoDao;

    /**
     * 干滩设备信息
     * @return
     */
    @Override
    public StaticDataInfoModel gantanDeviceInfo() {
        try {
            StaticDataInfoModel staticDataInfoModel = new StaticDataInfoModel();
            List<GantanDeviceInfoModel> gantanDeviceInfos = deviceStaticDataInfoDao.findGantanDeviceInfo();
            for (int i = 0; i < gantanDeviceInfos.size(); i++) {
                gantanDeviceInfos.get(i).setEquipno(StaticParamUtils.GANTANNO + (Integer.valueOf(gantanDeviceInfos.get(i).getEquipno()) >= 10 ? gantanDeviceInfos.get(i).getEquipno() : "0" + gantanDeviceInfos.get(i).getEquipno()));
                gantanDeviceInfos.get(i).setIs_used("1");
                gantanDeviceInfos.get(i).setIs_sync("0");
                //　经度　纬度
            }

            staticDataInfoModel.setTailingNo(StaticParamUtils.WKKNO);
            staticDataInfoModel.setDepartmentId("123456789");
            staticDataInfoModel.setProvinceId(StaticParamUtils.PROVINCENO);
            staticDataInfoModel.setType(StaticParamUtils.GANTANDEVICE);
            staticDataInfoModel.setSendTime(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
            staticDataInfoModel.setDatas(AESUtil.encrypt(JSONUtil.toJsonStr(gantanDeviceInfos), "BRlp%IYyTYFntG!g7oPo$N==", "wP!n$!ZD%0k2g6Gahpdk6l=="));
            System.out.println("干滩设备信息===========" + JSONUtil.toJsonStr(staticDataInfoModel));
            return staticDataInfoModel;
        }catch (Exception e){
            e.printStackTrace();
            return null;
        }
    }

    /**
     * 库水位设备信息
     * @return
     */
    @Override
    public StaticDataInfoModel kushuiweiDeviceInfo() {
        try {
            StaticDataInfoModel staticDataInfoModel = new StaticDataInfoModel();
            List<KushuiweiDeviceInfoModel> kushuiweiDeviceInfo = deviceStaticDataInfoDao.findKushuiweiDeviceInfo();
            for (int i = 0; i < kushuiweiDeviceInfo.size(); i++) {
                kushuiweiDeviceInfo.get(i).setEquipno(StaticParamUtils.KUSHUIWEINO + (Integer.valueOf(kushuiweiDeviceInfo.get(i).getEquipno()) >= 10 ? kushuiweiDeviceInfo.get(i).getEquipno() : "0" + kushuiweiDeviceInfo.get(i).getEquipno()));
                kushuiweiDeviceInfo.get(i).setIs_used("1");
                kushuiweiDeviceInfo.get(i).setIs_sync("0");
                // 经度　纬度

            }
            staticDataInfoModel.setTailingNo(StaticParamUtils.WKKNO);
            staticDataInfoModel.setDepartmentId("123456789");
            staticDataInfoModel.setProvinceId(StaticParamUtils.PROVINCENO);
            staticDataInfoModel.setType(StaticParamUtils.KUSHUIWEIDEVICE);
            staticDataInfoModel.setSendTime(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
            staticDataInfoModel.setDatas(AESUtil.encrypt(JSONUtil.toJsonStr(kushuiweiDeviceInfo), "BRlp%IYyTYFntG!g7oPo$N==", "wP!n$!ZD%0k2g6Gahpdk6l=="));
            System.out.println("库水位设备信息===========" + JSONUtil.toJsonStr(staticDataInfoModel));
            return staticDataInfoModel;
        }catch (Exception e){
            e.printStackTrace();
            return null;
        }
    }

    /**
     * 表面位移设备信息
     * @return
     */
    @Override
    public StaticDataInfoModel biaomianweiyiDeviceInfo() {
        try {
            StaticDataInfoModel staticDataInfoModel = new StaticDataInfoModel();
            List<BiaomianweiyiDeviceInfoModel> biaomianweiyiDeviceInfo = deviceStaticDataInfoDao.findBiaomianweiyiDeviceInfo();
            for (int i = 0; i < biaomianweiyiDeviceInfo.size(); i++) {
                biaomianweiyiDeviceInfo.get(i).setEquipno(StaticParamUtils.KUSHUIWEINO + (Integer.valueOf(biaomianweiyiDeviceInfo.get(i).getEquipno()) >= 10 ? biaomianweiyiDeviceInfo.get(i).getEquipno() : "0" + biaomianweiyiDeviceInfo.get(i).getEquipno()));
                biaomianweiyiDeviceInfo.get(i).setIs_used("1");
                biaomianweiyiDeviceInfo.get(i).setIs_sync("0");
                // 经度　纬度

            }
            staticDataInfoModel.setTailingNo(StaticParamUtils.WKKNO);
            staticDataInfoModel.setDepartmentId("123456789");
            staticDataInfoModel.setProvinceId(StaticParamUtils.PROVINCENO);
            staticDataInfoModel.setType(StaticParamUtils.BIAOMIANWEIYIDEVICE);
            staticDataInfoModel.setSendTime(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
            staticDataInfoModel.setDatas(AESUtil.encrypt(JSONUtil.toJsonStr(biaomianweiyiDeviceInfo), "BRlp%IYyTYFntG!g7oPo$N==", "wP!n$!ZD%0k2g6Gahpdk6l=="));
            System.out.println("表面位移设备信息===========" + JSONUtil.toJsonStr(staticDataInfoModel));
            return staticDataInfoModel;
        }catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    /**
     * 浸润线设备信息
     * @return
     */
    @Override
    public StaticDataInfoModel jinrunxianDeviceInfo() {
        try {
            StaticDataInfoModel staticDataInfoModel = new StaticDataInfoModel();
            List<JinrunxianDeviceInfoModel> jinrunxianDeviceInfo = deviceStaticDataInfoDao.findJinrunxianDeviceInfo();
            for (int i = 0; i < jinrunxianDeviceInfo.size(); i++) {
                jinrunxianDeviceInfo.get(i).setEquipno(StaticParamUtils.JINRUNXIANNO + (Integer.valueOf(jinrunxianDeviceInfo.get(i).getEquipno()) >= 10 ? jinrunxianDeviceInfo.get(i).getEquipno() : "0" + jinrunxianDeviceInfo.get(i).getEquipno()));
                jinrunxianDeviceInfo.get(i).setIs_used("1");
                jinrunxianDeviceInfo.get(i).setIs_sync("0");
                // 经度　纬度
            }
            staticDataInfoModel.setTailingNo(StaticParamUtils.WKKNO);
            staticDataInfoModel.setDepartmentId("123456789");
            staticDataInfoModel.setProvinceId(StaticParamUtils.PROVINCENO);
            staticDataInfoModel.setType(StaticParamUtils.JINRUNXIANDEVICE);
            staticDataInfoModel.setSendTime(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
            staticDataInfoModel.setDatas(AESUtil.encrypt(JSONUtil.toJsonStr(jinrunxianDeviceInfo), "BRlp%IYyTYFntG!g7oPo$N==", "wP!n$!ZD%0k2g6Gahpdk6l=="));
            System.out.println("浸润线设备信息===========" + JSONUtil.toJsonStr(staticDataInfoModel));
            return staticDataInfoModel;
        }catch (Exception e){
            e.printStackTrace();
            return null;
        }
    }

    /**
     * 降雨量设备信息
     * @return
     */
    @Override
    public StaticDataInfoModel jiangyuliangDeviceInfo() {
        try {
            StaticDataInfoModel staticDataInfoModel = new StaticDataInfoModel();
            List<JinrunxianDeviceInfoModel> jiangyuliangDeviceInfo = deviceStaticDataInfoDao.findJiangyuliangDeviceInfo();
            for (int i = 0; i < jiangyuliangDeviceInfo.size(); i++) {
                jiangyuliangDeviceInfo.get(i).setEquipno(StaticParamUtils.JIANGYULIANGNO + (Integer.valueOf(jiangyuliangDeviceInfo.get(i).getEquipno()) >= 10 ? jiangyuliangDeviceInfo.get(i).getEquipno() : "0" + jiangyuliangDeviceInfo.get(i).getEquipno()));
                jiangyuliangDeviceInfo.get(i).setIs_used("1");
                jiangyuliangDeviceInfo.get(i).setIs_sync("0");
                // 经度　纬度

            }
            staticDataInfoModel.setTailingNo(StaticParamUtils.WKKNO);
            staticDataInfoModel.setDepartmentId("123456789");
            staticDataInfoModel.setProvinceId(StaticParamUtils.PROVINCENO);
            staticDataInfoModel.setType(StaticParamUtils.JIANGYULIANGEDEVICE);
            staticDataInfoModel.setSendTime(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
            staticDataInfoModel.setDatas(AESUtil.encrypt(JSONUtil.toJsonStr(jiangyuliangDeviceInfo), "BRlp%IYyTYFntG!g7oPo$N==", "wP!n$!ZD%0k2g6Gahpdk6l=="));
            System.out.println("降雨量设备信息===========" + JSONUtil.toJsonStr(staticDataInfoModel));
            return staticDataInfoModel;
        }catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    /**
     * 内部位移
     * @return
     */
    @Override
    public StaticDataInfoModel neibuweiyiDeviceInfo() {
        try{
            StaticDataInfoModel staticDataInfoModel = new StaticDataInfoModel();
            List<NeibuweiyiDeviceInfoModel> neibuweiyiDeviceInfo = deviceStaticDataInfoDao.findNeibuweiyiDeviceInfo();
            for (int i = 0; i < neibuweiyiDeviceInfo.size(); i++) {
                neibuweiyiDeviceInfo.get(i).setEquipno(StaticParamUtils.NEIBUWEIYINO + (Integer.valueOf(neibuweiyiDeviceInfo.get(i).getEquipno()) >= 10 ? neibuweiyiDeviceInfo.get(i).getEquipno() : "0" + neibuweiyiDeviceInfo.get(i).getEquipno()));
                neibuweiyiDeviceInfo.get(i).setIs_used("1");
                neibuweiyiDeviceInfo.get(i).setIs_sync("0");
                // 经度　纬度

            }
            staticDataInfoModel.setTailingNo(StaticParamUtils.WKKNO);
            staticDataInfoModel.setDepartmentId("123456789");
            staticDataInfoModel.setProvinceId(StaticParamUtils.PROVINCENO);
            staticDataInfoModel.setType(StaticParamUtils.NEIBUWEIYIDEVICE);
            staticDataInfoModel.setSendTime(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
            staticDataInfoModel.setDatas(AESUtil.encrypt(JSONUtil.toJsonStr(neibuweiyiDeviceInfo), "BRlp%IYyTYFntG!g7oPo$N==", "wP!n$!ZD%0k2g6Gahpdk6l=="));
            System.out.println("内部位移设备信息===========" + JSONUtil.toJsonStr(staticDataInfoModel));
            return staticDataInfoModel;
        }catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }


}
