package com.amqp.shanxi.service.impl;

import cn.hutool.json.JSONUtil;
import com.amqp.shanxi.dao.RealTimeInfoDao;
import com.amqp.shanxi.model.*;
import com.amqp.shanxi.service.RealTimeInfoService;
import com.amqp.shanxi.util.AESUtil;
import com.amqp.shanxi.util.StaticParamUtils;
import org.springframework.amqp.core.AmqpTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

@Service
public class RealTimeInfoServiceImpl implements RealTimeInfoService {

    @Autowired
    private AmqpTemplate amqpTemplate;

    @Autowired
    private RealTimeInfoDao realTimeInfoDao;

    @Override
    public String gantanRealTimeData() {
        try {
            List<GantanRealTimeInfoModel> gantanRealTimeInfoModelList = realTimeInfoDao.findGantanRealTimeData();
            StaticDataInfoModel gantanRealTime = new StaticDataInfoModel();
            for (GantanRealTimeInfoModel gantanRealTimeInfoModel : gantanRealTimeInfoModelList) {
                // 未报警
                gantanRealTimeInfoModel.setSensorno(StaticParamUtils.GANTANNO + (gantanRealTimeInfoModel.getRecordid() >= 10 ? String.valueOf(gantanRealTimeInfoModel.getRecordid()) : "0" + gantanRealTimeInfoModel.getRecordid()));
                if (gantanRealTimeInfoModel.getCollectdate().contains(".")) {
                    gantanRealTimeInfoModel.setCollectdate(gantanRealTimeInfoModel.getCollectdate().substring(0, gantanRealTimeInfoModel.getCollectdate().indexOf(".")));
                }
            }
            System.out.println("gt实时数据=======================" + JSONUtil.toJsonStr(gantanRealTimeInfoModelList));

            gantanRealTime.setTailingNo(StaticParamUtils.WKKNO);
            gantanRealTime.setDepartmentId("123456789");
            gantanRealTime.setProvinceId(StaticParamUtils.PROVINCENO);
            gantanRealTime.setType(StaticParamUtils.GANTANDATA);
            gantanRealTime.setSendTime(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
            gantanRealTime.setDatas(AESUtil.encrypt(JSONUtil.toJsonStr(gantanRealTimeInfoModelList), "BRlp%IYyTYFntG!g7oPo$N==", "wP!n$!ZD%0k2g6Gahpdk6l=="));
            return JSONUtil.toJsonStr(gantanRealTime);
        }catch(Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    @Override
    public String kushuiweiRealTimeData() {
        try {
            List<KushuiweiRealTimeInfoModel> kushuiweiRealTimeData = realTimeInfoDao.findKushuiweiRealTimeData();
            StaticDataInfoModel kswRealTimeData = new StaticDataInfoModel();
            List<KushuiweiAlarmInfoModel> kswAlarmInfoModelList = null;
            for (KushuiweiRealTimeInfoModel kushuiweiRealTimeInfoModel : kushuiweiRealTimeData) {
                // 未报警
                kushuiweiRealTimeInfoModel.setSensorno(StaticParamUtils.KUSHUIWEINO + (kushuiweiRealTimeInfoModel.getRecordid() >= 10 ? String.valueOf(kushuiweiRealTimeInfoModel.getRecordid()) : "0" + kushuiweiRealTimeInfoModel.getRecordid()));
                if (kushuiweiRealTimeInfoModel.getCollectdate().contains(".")) {
                    kushuiweiRealTimeInfoModel.setCollectdate(kushuiweiRealTimeInfoModel.getCollectdate().substring(0, kushuiweiRealTimeInfoModel.getCollectdate().indexOf(".")));
                }
            }
            System.out.println("ksw实时数据=======================" + JSONUtil.toJsonStr(kushuiweiRealTimeData));

            kswRealTimeData.setTailingNo(StaticParamUtils.WKKNO);
            kswRealTimeData.setDepartmentId("123456789");
            kswRealTimeData.setProvinceId(StaticParamUtils.PROVINCENO);
            kswRealTimeData.setType(StaticParamUtils.KUSHUIWEIDATA);
            kswRealTimeData.setSendTime(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
            kswRealTimeData.setDatas(AESUtil.encrypt(JSONUtil.toJsonStr(kushuiweiRealTimeData), "BRlp%IYyTYFntG!g7oPo$N==", "wP!n$!ZD%0k2g6Gahpdk6l=="));
            return JSONUtil.toJsonStr(kswRealTimeData);
        }catch(Exception e) {
            e.printStackTrace();
            return null;
        }
    }


    @Override
    public String biaomianweiyiRealTimeData() {
        try {
            List<BiaomianweiyiRealTimeInfoModel> biaomianweiyiRealTimeData = realTimeInfoDao.findBiaomianweiyiRealTimeData();
            StaticDataInfoModel bmwyRealTimeData = new StaticDataInfoModel();
            List<BiaomianweiyiAlarmInfoModel> bmwyAlarmInfoModelList = null;
            for (int i = 0; i < biaomianweiyiRealTimeData.size(); i++) {
                // 未报警
                biaomianweiyiRealTimeData.get(i).setSensorno(StaticParamUtils.BIAOMIANWEIYINO + (biaomianweiyiRealTimeData.get(i).getRecordid() >= 10 ? String.valueOf(biaomianweiyiRealTimeData.get(i).getRecordid()) : "0" + biaomianweiyiRealTimeData.get(i).getRecordid()));
                if (biaomianweiyiRealTimeData.get(i).getCollectdate().contains(".")) {
                    biaomianweiyiRealTimeData.get(i).setCollectdate(biaomianweiyiRealTimeData.get(i).getCollectdate().substring(0, biaomianweiyiRealTimeData.get(i).getCollectdate().indexOf(".")));
                }
            }
            System.out.println("bmwy实时数据=======================" + JSONUtil.toJsonStr(biaomianweiyiRealTimeData));

            bmwyRealTimeData.setTailingNo(StaticParamUtils.WKKNO);
            bmwyRealTimeData.setDepartmentId("123456789");
            bmwyRealTimeData.setProvinceId(StaticParamUtils.PROVINCENO);
            bmwyRealTimeData.setType(StaticParamUtils.BIAOMIANWEIYIDATA);
            bmwyRealTimeData.setSendTime(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
            bmwyRealTimeData.setDatas(AESUtil.encrypt(JSONUtil.toJsonStr(biaomianweiyiRealTimeData), "BRlp%IYyTYFntG!g7oPo$N==", "wP!n$!ZD%0k2g6Gahpdk6l=="));
            return JSONUtil.toJsonStr(bmwyRealTimeData);
        }catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    @Override
    public String jinrunxianRealTimeData() {
        try {
            List<JinrunxianRealTimeInfoModel> jinrunxianRealTimeData = realTimeInfoDao.findJinrunxianRealTimeData();
            StaticDataInfoModel jrxRealTimeData = new StaticDataInfoModel();
            List<JinrunxianAlarmInfoModel> jrxAlarmInfoModelList = null;
            for (int i = 0; i < jinrunxianRealTimeData.size(); i++) {
                // 未报警
                jinrunxianRealTimeData.get(i).setSensorno(StaticParamUtils.JINRUNXIANNO + (jinrunxianRealTimeData.get(i).getRecordid() >= 10 ? String.valueOf(jinrunxianRealTimeData.get(i).getRecordid()) : "0" + jinrunxianRealTimeData.get(i).getRecordid()));
                if (jinrunxianRealTimeData.get(i).getCollectdate().contains(".")) {
                    jinrunxianRealTimeData.get(i).setCollectdate(jinrunxianRealTimeData.get(i).getCollectdate().substring(0, jinrunxianRealTimeData.get(i).getCollectdate().indexOf(".")));
                }
            }
            System.out.println("jrx实时数据=======================" + JSONUtil.toJsonStr(jinrunxianRealTimeData));

            jrxRealTimeData.setTailingNo(StaticParamUtils.WKKNO);
            jrxRealTimeData.setDepartmentId("123456789");
            jrxRealTimeData.setProvinceId(StaticParamUtils.PROVINCENO);
            jrxRealTimeData.setType(StaticParamUtils.JINRUNXIANDATA);
            jrxRealTimeData.setSendTime(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
            jrxRealTimeData.setDatas(AESUtil.encrypt(JSONUtil.toJsonStr(jinrunxianRealTimeData), "BRlp%IYyTYFntG!g7oPo$N==", "wP!n$!ZD%0k2g6Gahpdk6l=="));
            return JSONUtil.toJsonStr(jrxRealTimeData);
        }catch(Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    @Override
    public String jiangyuliangRealTimeData() {
        try {
            List<JiangyuliangRealTimeInfoModel> jiangyuliangRealTimeData = realTimeInfoDao.findJiangyuliangRealTimeData();
            StaticDataInfoModel jylRealTimeData = new StaticDataInfoModel();
            List<JiangyuliangAlarmInfoModel> jylAlarmInfoModelList = null;
            for (int i = 0; i < jiangyuliangRealTimeData.size(); i++) {
                // 未报警
                jiangyuliangRealTimeData.get(i).setSensorno(StaticParamUtils.JIANGYULIANGNO + (jiangyuliangRealTimeData.get(i).getRecordid() >= 10 ? String.valueOf(jiangyuliangRealTimeData.get(i).getRecordid()) : "0" + jiangyuliangRealTimeData.get(i).getRecordid()));
                if (jiangyuliangRealTimeData.get(i).getCollectdate().contains(".")) {
                    jiangyuliangRealTimeData.get(i).setCollectdate(jiangyuliangRealTimeData.get(i).getCollectdate().substring(0, jiangyuliangRealTimeData.get(i).getCollectdate().indexOf(".")));
                }
            }
            System.out.println("jyl实时数据=======================" + JSONUtil.toJsonStr(jiangyuliangRealTimeData));

            jylRealTimeData.setTailingNo(StaticParamUtils.WKKNO);
            jylRealTimeData.setDepartmentId("123456789");
            jylRealTimeData.setProvinceId(StaticParamUtils.PROVINCENO);
            jylRealTimeData.setType(StaticParamUtils.JIANGYULIANGDATA);
            jylRealTimeData.setSendTime(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
            jylRealTimeData.setDatas(AESUtil.encrypt(JSONUtil.toJsonStr(jiangyuliangRealTimeData), "BRlp%IYyTYFntG!g7oPo$N==", "wP!n$!ZD%0k2g6Gahpdk6l=="));
            return JSONUtil.toJsonStr(jylRealTimeData);
        }catch (Exception e){
            e.printStackTrace();
            return null;
        }
    }

    /**
     * 监测设备
     */
    @Override
    public String deviceRealTimeData() {
        try {
            StaticDataInfoModel deviceRealTimeDataModel = new StaticDataInfoModel();
            List<DeviceRealTimeInfoModel> deviceRealTimeData = realTimeInfoDao.findDeviceRealTimeData();
            for (int i = 0; i < deviceRealTimeData.size(); i++) {
                if (deviceRealTimeData.get(i).getItemno().contains("干滩")) {
                    deviceRealTimeData.get(i).setItemno("01");
                } else if (deviceRealTimeData.get(i).getItemno().contains("库水位")) {
                    deviceRealTimeData.get(i).setItemno("02");
                } else if (deviceRealTimeData.get(i).getItemno().contains("坝体表面位移")) {
                    deviceRealTimeData.get(i).setItemno("03");
                } else if (deviceRealTimeData.get(i).getItemno().contains("雨量计")) {
                    deviceRealTimeData.get(i).setItemno("06");
                } else if (deviceRealTimeData.get(i).getItemno().contains("浸润线")) {
                    deviceRealTimeData.get(i).setItemno("05");
                } else if (deviceRealTimeData.get(i).getItemno().contains("坝体内部")) {
                    deviceRealTimeData.get(i).setItemno("04");
                }

                if (deviceRealTimeData.get(i).getState() != null) {
                    deviceRealTimeData.get(i).setState("1");
                } else {
                    deviceRealTimeData.get(i).setState("0");
                }
                deviceRealTimeData.get(i).setCollectdate(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));

            }

            System.out.println("device实时数据=======================" + JSONUtil.toJsonStr(deviceRealTimeData));

            deviceRealTimeDataModel.setTailingNo(StaticParamUtils.WKKNO);
            deviceRealTimeDataModel.setDepartmentId("123456789");
            deviceRealTimeDataModel.setProvinceId(StaticParamUtils.PROVINCENO);
            deviceRealTimeDataModel.setType(StaticParamUtils.DEVICEDATA);
            deviceRealTimeDataModel.setSendTime(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
            deviceRealTimeDataModel.setDatas(AESUtil.encrypt(JSONUtil.toJsonStr(deviceRealTimeData), "BRlp%IYyTYFntG!g7oPo$N==", "wP!n$!ZD%0k2g6Gahpdk6l=="));
            return JSONUtil.toJsonStr(deviceRealTimeDataModel);
        }catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    @Override
    public String wkkRealTimeData() {
        try{
            StaticDataInfoModel wkkRealTimeDataModel = new StaticDataInfoModel();
            List<WkkRealTimeInfoModel> wkkRealTimeData = realTimeInfoDao.findWkkRealTimeData();
            if (wkkRealTimeData.size() > 0) {
                wkkRealTimeData.get(0).setState("1");
                wkkRealTimeData.get(0).setCollectdat(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
                wkkRealTimeDataModel.setTailingNo(StaticParamUtils.WKKNO);
                wkkRealTimeDataModel.setDepartmentId("123456789");
                wkkRealTimeDataModel.setProvinceId(StaticParamUtils.PROVINCENO);
                wkkRealTimeDataModel.setType(StaticParamUtils.WKKDATA);
                wkkRealTimeDataModel.setSendTime(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
                wkkRealTimeDataModel.setDatas(AESUtil.encrypt(JSONUtil.toJsonStr(wkkRealTimeData), "BRlp%IYyTYFntG!g7oPo$N==", "wP!n$!ZD%0k2g6Gahpdk6l=="));
                System.out.println("wkk实时数据=======================" + JSONUtil.toJsonStr(wkkRealTimeData));
                return JSONUtil.toJsonStr(wkkRealTimeDataModel);
            }else {
                WkkRealTimeInfoModel wkkRealTimeInfoModel = new WkkRealTimeInfoModel();
                wkkRealTimeInfoModel.setCollectdat(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
                wkkRealTimeInfoModel.setState("0");
                wkkRealTimeData.add(wkkRealTimeInfoModel);

                wkkRealTimeDataModel.setTailingNo(StaticParamUtils.WKKNO);
                wkkRealTimeDataModel.setDepartmentId("123456789");
                wkkRealTimeDataModel.setProvinceId(StaticParamUtils.PROVINCENO);
                wkkRealTimeDataModel.setType(StaticParamUtils.WKKDATA);
                wkkRealTimeDataModel.setSendTime(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
                wkkRealTimeDataModel.setDatas(AESUtil.encrypt(JSONUtil.toJsonStr(wkkRealTimeData), "BRlp%IYyTYFntG!g7oPo$N==", "wP!n$!ZD%0k2g6Gahpdk6l=="));
                System.out.println("wkk实时数据=======================" + JSONUtil.toJsonStr(wkkRealTimeData));
                return JSONUtil.toJsonStr(wkkRealTimeDataModel);
            }
        }catch(Exception e)  {
            e.printStackTrace();
            return null;
        }
    }


    /**
     * 设备离线
     */
    @Override
    public String deviceOffLineData() {
        try {
            StaticDataInfoModel deviceOffLineDataModel = new StaticDataInfoModel();
            List<DeviceOffLineInfoModel> deviceOffLineData = realTimeInfoDao.findDeviceOffLineData();
            if(deviceOffLineData.size() > 0) {
                // 有离线设备
                for(int i = 0; i < deviceOffLineData.size(); i++) {
                    deviceOffLineData.get(i).setSensorno(StaticParamUtils.JIANGYULIANGNO + (deviceOffLineData.get(i).getRecordid() >= 10 ? String.valueOf(deviceOffLineData.get(i).getRecordid()): "0" + deviceOffLineData.get(i).getRecordid()));
                    deviceOffLineData.get(i).setCollectdate(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
                }
                deviceOffLineDataModel.setTailingNo(StaticParamUtils.WKKNO);
                deviceOffLineDataModel.setDepartmentId("123456789");
                deviceOffLineDataModel.setProvinceId(StaticParamUtils.PROVINCENO);
                deviceOffLineDataModel.setType(StaticParamUtils.DEVICEOFFLINE);
                deviceOffLineDataModel.setSendTime(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
                deviceOffLineDataModel.setDatas(AESUtil.encrypt(JSONUtil.toJsonStr(deviceOffLineData), "BRlp%IYyTYFntG!g7oPo$N==" , "wP!n$!ZD%0k2g6Gahpdk6l=="));
            }
            return JSONUtil.toJsonStr(deviceOffLineData);
        }catch(Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    @Override
    public String neibuChenJiangRealTimeData() {
        try {
            List<NeibuweiyiRealTimeInfoModel> neibuChenjiangRealTimeData = realTimeInfoDao.findNeibuChenjiangRealTimeData();
            StaticDataInfoModel nbcjRealTimeData = new StaticDataInfoModel();
            for (int i = 0; i < neibuChenjiangRealTimeData.size(); i++) {
                // 未报警
                neibuChenjiangRealTimeData.get(i).setSensorno(StaticParamUtils.BIAOMIANWEIYINO + (neibuChenjiangRealTimeData.get(i).getRecordid() >= 10 ? String.valueOf(neibuChenjiangRealTimeData.get(i).getRecordid()) : "0" + neibuChenjiangRealTimeData.get(i).getRecordid()));
                if (neibuChenjiangRealTimeData.get(i).getCollectdate().contains(".")) {
                    neibuChenjiangRealTimeData.get(i).setCollectdate(neibuChenjiangRealTimeData.get(i).getCollectdate().substring(0, neibuChenjiangRealTimeData.get(i).getCollectdate().indexOf(".")));
                }
            }
            System.out.println("内部沉降实时数据=======================" + JSONUtil.toJsonStr(neibuChenjiangRealTimeData));

            nbcjRealTimeData.setTailingNo(StaticParamUtils.WKKNO);
            nbcjRealTimeData.setDepartmentId("123456789");
            nbcjRealTimeData.setProvinceId(StaticParamUtils.PROVINCENO);
            nbcjRealTimeData.setType(StaticParamUtils.NEIBUWEIYIDATA);
            nbcjRealTimeData.setSendTime(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
            nbcjRealTimeData.setDatas(AESUtil.encrypt(JSONUtil.toJsonStr(neibuChenjiangRealTimeData), "BRlp%IYyTYFntG!g7oPo$N==", "wP!n$!ZD%0k2g6Gahpdk6l=="));
            return JSONUtil.toJsonStr(nbcjRealTimeData);
        }catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }


    @Override
    public String neibuShuiPingRealTimeData() {
        try {
            List<NeibuweiyiRealTimeInfoModel> neibuShuipingRealTimeData = realTimeInfoDao.findNeibuShuipingRealTimeData();
            StaticDataInfoModel nbcjRealTimeData = new StaticDataInfoModel();
            for (int i = 0; i < neibuShuipingRealTimeData.size(); i++) {
                // 未报警
                neibuShuipingRealTimeData.get(i).setSensorno(StaticParamUtils.BIAOMIANWEIYINO + (neibuShuipingRealTimeData.get(i).getRecordid() >= 10 ? String.valueOf(neibuShuipingRealTimeData.get(i).getRecordid()) : "0" + neibuShuipingRealTimeData.get(i).getRecordid()));
                if (neibuShuipingRealTimeData.get(i).getCollectdate().contains(".")) {
                    neibuShuipingRealTimeData.get(i).setCollectdate(neibuShuipingRealTimeData.get(i).getCollectdate().substring(0, neibuShuipingRealTimeData.get(i).getCollectdate().indexOf(".")));
                }
            }
            System.out.println("内部水平实时数据=======================" + JSONUtil.toJsonStr(neibuShuipingRealTimeData));

            nbcjRealTimeData.setTailingNo(StaticParamUtils.WKKNO);
            nbcjRealTimeData.setDepartmentId("123456789");
            nbcjRealTimeData.setProvinceId(StaticParamUtils.PROVINCENO);
            nbcjRealTimeData.setType(StaticParamUtils.NEIBUWEIYIDATA);
            nbcjRealTimeData.setSendTime(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date()));
            nbcjRealTimeData.setDatas(AESUtil.encrypt(JSONUtil.toJsonStr(neibuShuipingRealTimeData), "BRlp%IYyTYFntG!g7oPo$N==", "wP!n$!ZD%0k2g6Gahpdk6l=="));
            return JSONUtil.toJsonStr(nbcjRealTimeData);
        }catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }
}
